# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _calanalysis
else:
    import _calanalysis

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class calanalysis(object):
    r"""Proxy of C++ casac::calanalysis class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self):
        r"""__init__(self) -> calanalysis"""
        _calanalysis.calanalysis_swiginit(self, _calanalysis.new_calanalysis())

    def open(self, *args, **kwargs):
        r"""
        open(self, _caltable=string("")) -> bool


        Summary:
             Open a calibration table.

        Description:


        This member function opens a calibration table.

        Input Parameters:
            caltable                   Python string containing the calibration table name. 

        Example:

        ca.open( '<caltable name>' )

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_open(self, *args, **kwargs)

    def close(self):
        r"""
        close(self) -> bool


        Summary:
             Close a calibration table.

        Description:


        This member function closes a calibration table.

        Example:

        ca.close()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_close(self)

    def calname(self):
        r"""
        calname(self) -> string


        Summary:
             Return the calibration table name.

        Description:


        This member function returns calibration table name.

        Example:

        caltable = ca.calname()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_calname(self)

    def msname(self):
        r"""
        msname(self) -> string


        Summary:
             Return the name of the MS that created this calibration table.

        Description:


        This member function returns the name of the MS that created this calibration
        table.

        Example:

        msname = ca.msname()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_msname(self)

    def viscal(self):
        r"""
        viscal(self) -> string


        Summary:
             Return the type of calibration table ('B', 'G', 'T', etc.).

        Description:


        This member function returns the type of calibration table ('B', 'G', 'T',
        etc.).

        Example:

        viscal = ca.viscal()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_viscal(self)

    def partype(self):
        r"""
        partype(self) -> string


        Summary:
             Return the parameter column type in the calibration table ('Complex' or 'Float').

        Description:


        This member function returns the parameter column type in the calibration table
        ('Complex' or 'Float').

        Example:

        partype = ca.partype()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_partype(self)

    def polbasis(self):
        r"""
        polbasis(self) -> string


        Summary:
             Return the polarization basis in the calibration table ('L' for linear or 'C' for circular).

        Description:


        This member function returns the polarization basis in the calibration table
        ('L' for linear or 'C' for circular).

        Example:

        polbasis = ca.polbasis()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_polbasis(self)

    def numfield(self):
        r"""
        numfield(self) -> long


        Summary:
             Return the number of fields in the calibration table.

        Description:


        This member function returns the number of fields in the calibration table.

        Example:

        numfield = ca.numfield()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numfield(self)

    def field(self, *args, **kwargs):
        r"""
        field(self, _name=bool(true)) -> std::vector< std::string >


        Summary:
             Return the fields in the calibration table.

        Description:


        This member function returns the fields in the calibration table.

        Input Parameters:
            name                       The python boolean which determines whether field names (True) or field numbers (False) are returned. 

        Example:

        field = ca.field()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_field(self, *args, **kwargs)

    def numantenna(self):
        r"""
        numantenna(self) -> long


        Summary:
             Return the number of antennas in the calibration table.

        Description:


        This member function returns the number of antennas in the calibration table.

        Example:

        numantenna = ca.numantenna()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numantenna(self)

    def numantenna1(self):
        r"""
        numantenna1(self) -> long


        Summary:
             Return the number of antenna 1s in the calibration table.

        Description:


        This member function returns the number of antenna 1s in the calibration table.

        Example:

        numantenna1 = ca.numantenna1()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numantenna1(self)

    def numantenna2(self):
        r"""
        numantenna2(self) -> long


        Summary:
             Return the number of antenna 2s in the calibration table.

        Description:


        This member function returns the number of antenna 2s in the calibration table.

        Example:

        numantenna2 = ca.numantenna2()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numantenna2(self)

    def antenna(self, *args, **kwargs):
        r"""
        antenna(self, _name=bool(true)) -> std::vector< std::string >


        Summary:
             Return the antennas in the calibration table.

        Description:


        This member function returns the antennas in the calibration table.

        Input Parameters:
            name                       The python boolean which determines whether antenna names (True) or antenna numbers (False) are returned. 

        Example:

        antenna = ca.antenna()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_antenna(self, *args, **kwargs)

    def antenna1(self, *args, **kwargs):
        r"""
        antenna1(self, _name=bool(true)) -> std::vector< std::string >


        Summary:
             Return the antenna 1s in the calibration table.

        Description:


        This member function returns the antenna 1s in the calibration table.

        Input Parameters:
            name                       The python boolean which determines whether antenna 1 names (True) or antenna 1 numbers (False) are returned. 

        Example:

        antenna1 = ca.antenna1()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_antenna1(self, *args, **kwargs)

    def antenna2(self, *args, **kwargs):
        r"""
        antenna2(self, _name=bool(true)) -> std::vector< std::string >


        Summary:
             Return the antenna 2s in the calibration table.

        Description:


        This member function returns the antenna 2s in the calibration table.

        Input Parameters:
            name                       The python boolean which determines whether antenna 2 names (True) or antenna 2 numbers (False) are returned. 

        Example:

        antenna2 = ca.antenna2()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_antenna2(self, *args, **kwargs)

    def numfeed(self):
        r"""
        numfeed(self) -> long


        Summary:
             Return the number of feeds in the calibration table.

        Description:


        This member function returns the number of feeds in the calibration table.

        Example:

        numfeed = ca.numfeed()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numfeed(self)

    def feed(self):
        r"""
        feed(self) -> std::vector< std::string >


        Summary:
             Return the feeds in the calibration table.

        Description:


        This member function returns the feeds in the calibration table.

        Example:

        feed = ca.feed()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_feed(self)

    def numtime(self):
        r"""
        numtime(self) -> long


        Summary:
             Return the number of times in the calibration table.

        Description:


        This member function returns the number of times in the calibration table.

        Example:

        numtime = ca.numtime()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numtime(self)

    def time(self):
        r"""
        time(self) -> std::vector< double >


        Summary:
             Return the times (in MJD seconds) in the calibration table.

        Description:


        This member function returns the times (in MJD seconds) in the calibration
        table.

        Example:

        time = ca.time()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_time(self)

    def numspw(self):
        r"""
        numspw(self) -> long


        Summary:
             Return the number of spectral windows in the calibration table.

        Description:


        This member function returns the number of spectral windows in the calibration
        table.

        Example:

        numspw = ca.numspw()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numspw(self)

    def spw(self, *args, **kwargs):
        r"""
        spw(self, _name=bool(true)) -> std::vector< std::string >


        Summary:
             Return the spectral windows in the calibration table.

        Description:


        This member function returns the spectral windows in the calibration table.

        Input Parameters:
            name                       The python boolean which determines whether spectral window names (True) or spectral window numbers (False) are returned. 

        Example:

        spw = ca.spw()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_spw(self, *args, **kwargs)

    def numchannel(self):
        r"""
        numchannel(self) -> std::vector< long >


        Summary:
             Return the number of channels per spectral window in the calibration table.

        Description:


        This member function returns the number of channels per spectral window in the
        calibration table.

        Example:

        numChannel = ca.numchannel()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_numchannel(self)

    def freq(self):
        r"""
        freq(self) -> record *


        Summary:
             Return the frequencies per spectral window in the calibration table.

        Description:


        This member function returns the frequencies per spectral window in the
        calibration table.

        Example:

        freq = ca.freq()

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_freq(self)

    def get(self, *args, **kwargs):
        r"""
        get(self, _field=variant( ), _antenna=variant( ), _timerange=variant( ), _spw=variant( ), _feed=variant( ), _axis=string("TIME"), _ap=string("AMPLITUDE"), _norm=bool(false), _unwrap=bool(false), _jumpmax=double(0.0)) -> record *


        Summary:
             Return the calibration data.

        Description:


        This member function returns the calibration data.

        Input Parameters:
            field                      The python comma-delimited string or list of strings containing the field names or numbers.  The default is '' (all fields). 
            antenna                    The python comma-delimited string or list of strings containing the antenna 1s and antenna 2s.  The default is '' (all antenna 1s and antenna 2s). 
            timerange                  The python list of floats of length two containing the start and stop times (in MJD seconds).  The default is [] (the minimum start time and the maximum stop time). 
            spw                        The python comma-delimited string containing the spectral window names and numbers along with their channel numbers.  The default is '' (all spectral windows and channels). 
            feed                       The python comma-delimited string or list of strings containing the feeds. The default is '' (all feeds). 
            axis                       The python string containing the user-specified iteration axis.  The allowed values are 'TIME' and 'FREQ'.  The default is '' ('FREQ'). 
            ap                         The python string which determines whether complex gains are converted to amplitudes or phases.  The allowed values are 'AMPLITUDE' and 'PHASE'. The default is '' ('AMPLITUDE').  This parameter is ignored when the 'gain' values in the calibration table are real. 
            norm                       The python boolean which determines whether the amplitudes are normalized along each non-iteration axis.  The default is False.  This parameter is ignored when the 'gain' values in the calibration table are real or ap='PHASE'. 
            unwrap                     The python boolean which determines whether the phases are unwrapped along each non-iteration axis.  The default is False.  This parameter is ignored when the 'gain' values in the calibration table are real or ap='AMPLITUDE'. 
            jumpmax                    The python float which determines the maximum phase jump near +/- PI before unwrapping is performed.  E.g., jumpmax = 0.1.  The default is 0.0. It is ignored if the 'gain' values in the calibration table are real or ap = 'AMPLITUDE'.  If the non-iteration axis is frequency: 1) if jumpmax == 0.0, use fringe fitting (only available when the non-iteration axis is time); 2) if jumpmax != 0.0, use simple unwrapping (same algorithm as used when the non-iteration axis is time or frequency). 

        Example:

        # All data limited only by the spectral window and channel input
        data = ca.get( spw='0:4~15,1,2:10~20' )

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_get(self, *args, **kwargs)

    def fit(self, *args, **kwargs):
        r"""
        fit(self, _field=variant( ), _antenna=variant( ), _timerange=variant( ), _spw=variant( ), _feed=variant( ), _axis=string("TIME"), _ap=string("AMPLITUDE"), _norm=bool(false), _unwrap=bool(false), _jumpmax=double(0.0), _order=string("AVERAGE"), _type=string("LSQ"), _weight=bool(false)) -> record *


        Summary:
             Return the calibration data and fits along the non-iteration axis.

        Description:


        This member function returns the calibration data and fits along the
        non-iteration axis.

        Input Parameters:
            field                      The python comma-delimited string or list of strings containing the field names or numbers.  The default is '' (all fields). 
            antenna                    The python comma-delimited string or list of strings containing the antenna 1s and antenna 2s.  The default is '' (all antenna 1s and antenna 2s). 
            timerange                  The python list of floats of length two containing the start and stop times (in MJD seconds).  The default is [] (the minimum start time and the maximum stop time). 
            spw                        The python comma-delimited string containing the spectral window names and numbers along with their channel numbers.  The default is '' (all spectral windows and channels). 
            feed                       The python comma-delimited string or list of strings containing the feeds. The default is '' (all feeds). 
            axis                       The python string containing the user-specified iteration axis.  The allowed values are 'TIME' and 'FREQ'.  The default is '' ('FREQ'). 
            ap                         The python string which determines whether complex gains are converted to amplitudes or phases.  The allowed values are 'AMPLITUDE' and 'PHASE'. The default is '' ('AMPLITUDE').  This parameter is ignored when the 'gain' values in the calibration table are real. 
            norm                       The python boolean which determines whether the amplitudes are normalized along each non-iteration axis.  The default is False.  This parameter is ignored when the 'gain' values in the calibration table are real or ap='PHASE'. 
            unwrap                     The python boolean which determines whether the phases are unwrapped along each non-iteration axis.  The default is False.  This parameter is ignored when the 'gain' values in the calibration table are real or ap='AMPLITUDE'. 
            jumpmax                    The python float which determines the maximum phase jump near +/- PI before unwrapping is performed.  E.g., jumpmax = 0.1.  The default is 0.0. It is ignored if the 'gain' values in the calibration table are real or ap = 'AMPLITUDE'.  If the non-iteration axis is frequency: 1) if jumpmax == 0.0, use fringe fitting (only available when the non-iteration axis is time); 2) if jumpmax != 0.0, use simple unwrapping (same algorithm as used when the non-iteration axis is time or frequency). 
            order                      The python string containing the fit order.  The allowed values are 'AVERAGE', 'LINEAR', and 'QUADRATIC'.  The default is '' ('AVERAGE').  NB: 'QUADRATIC' is not allowed when type = 'ROBUST'. 
            type                       The python string containing the fit type.  The allowed values are 'LSQ' and 'ROBUST'.  The default is '' ('LSQ').  NB: Robust fitting is experimental.  It flags outliers. 
            weight                     The python boolean which determines the weighting.  The default is False. 

        Example:

        # All data limited only by the spectral window and channel input.  The fit order
        # is linear.
        data_fit = ca.fit( spw='0:4~15,1,2:10~20', order='LINEAR' )

        --------------------------------------------------------------------------------

        """
        return _calanalysis.calanalysis_fit(self, *args, **kwargs)
    __swig_destroy__ = _calanalysis.delete_calanalysis

# Register calanalysis in _calanalysis:
_calanalysis.calanalysis_swigregister(calanalysis)

