# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _wvr
else:
    import _wvr

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class wvr(object):
    r"""Proxy of C++ casac::wvr class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self):
        r"""__init__(self) -> wvr"""
        _wvr.wvr_swiginit(self, _wvr.new_wvr())

    def gcal(self, *args, **kwargs):
        r"""
        gcal(self, _vis=string(""), _output=string(""), _toffset=double(0.), _nsol=long(1), _segsource=bool(false), _reverse=bool(false), _reversespw=std::vector< long >({}), _disperse=bool(false), _cont=bool(false), _wvrflag=string(""), _sourceflag=std::vector< std::string >({}), _statfield=std::vector< std::string >({}), _statsource=std::vector< std::string >({}), _tie=std::vector< std::string >({}), _smooth=long(1), _scale=double(1.0), _maxdistm=double(500.), _minnumants=long(2), _mingoodfrac=double(0.8), _usefieldtab=bool(false), _spw=std::vector< long >({}), _wvrspw=std::vector< long >({}), _refant=string(""), _offsets=string(""), _rseed=long(0), _logfile=string("wvrgcal.log")) -> long


        Summary:
            Generate a calibration table based on the WVR data in the given MS

        Description:


        Generate a gain table based on Water Vapour Radiometer data


        Input Parameters:
            vis                       Input measurement set
            output                    Name of the output file
            toffset                    Time offset (in seconds) between interferometric and WVR data 
            nsol                       Number of solutions for phase correction coefficients to make during this observation 
            segsource                  Do a new coefficient calculation for each source 
            reverse                    Reverse the sign of correction in all SPW (e.g. due to AIV-1740) 
            reversespw                 Reverse the sign correction for these spws 
            disperse                   Apply correction for dispersion 
            cont                       UNTESTED! Estimate the continuum (e.g., due to clouds) 
            wvrflag                    Regard this WVR (labelled with either antenna number or antenna name) as bad, and use interpolated values instead. (Can be comma-separated list without spaces.) 
            sourceflag                 Flag the WVR data for this source and do not produce any phase corrections on it 
            statfield                  Compute the statistics (Phase RMS, Disc) on this field only 
            statsource                 Compute the statistics (Phase RMS, Disc) on this source only 
            tie                        Prioritise tieing the phase of these sources as well as possible 
            smooth                     Smooth WVR data by this many samples before applying the correction 
            scale                      Scale the entire phase correction by this factor 
            maxdistm                   Maximum distance (m) an antenna may have to be considered for being part of the set of up to 3 antennas for interpolation of a solution for a flagged antenna 
            minnumants                 Minimum number of near antennas (up to 3) required for interpolation 
            mingoodfrac                If the fraction of unflagged data for an antenna is below this value (0. to 1.), the antenna is flagged 
            usefieldtab                Derive the antenna pointing information from the FIELD table instead of the POINTING table 
            spw                        Only write out corrections for these SPWs. 
            wvrspw                     Only use data from these WVR SPWs. 
            refant                     Use the WVR data from this antenna for calculating the dT/dL parameters. (Can be comma-separated ranked list without spaces.) 
            offsets                    Name of the optional input table containing the temperature offsets, e.g. generated by remove_cloud 
            rseed                      random seed (integer) for the wvrgcal fitting routine (0 == use internal default) 
            logfile                   Name of the log file (existing file will be overwritten)

        --------------------------------------------------------------------------------

        """
        return _wvr.wvr_gcal(self, *args, **kwargs)
    __swig_destroy__ = _wvr.delete_wvr

# Register wvr in _wvr:
_wvr.wvr_swigregister(wvr)

