##################### generated by xml-casa (v2) from calanalysis.xml ###############
##################### 876211c3a83f995d560f64a2e19f5adf ##############################
from __future__ import absolute_import 
from .__casac__.calanalysis import calanalysis as _calanalysis

from .errors import create_error_string
from .typecheck import CasaValidator as _validator
_pc = _validator( )
from .coercetype import coerce as _coerce


class calanalysis:
    _info_group_ = """calanalysis"""
    _info_desc_ = """
Get and fit data from a calibration table (CASA 3.4 and later).
"""
    ### self
    def __init__(self, *args, **kwargs):
        """Construct a calibration analysis tool.
        """
        self._swigobj = kwargs.get('swig_object',None)
        if self._swigobj is None:
            self._swigobj = _calanalysis()

    def open(self, caltable=''):
        """This member function opens a calibration table.
        """
        return self._swigobj.open(caltable)

    def close(self):
        """This member function closes a calibration table.
        """
        return self._swigobj.close()

    def calname(self):
        """This member function returns calibration table name.
        """
        return self._swigobj.calname()

    def msname(self):
        """This member function returns the name of the MS that created this calibration
        table.
        """
        return self._swigobj.msname()

    def viscal(self):
        """This member function returns the type of calibration table ('B', 'G', 'T',
        etc.).
        """
        return self._swigobj.viscal()

    def partype(self):
        """This member function returns the parameter column type in the calibration table
        ('Complex' or 'Float').
        """
        return self._swigobj.partype()

    def polbasis(self):
        """This member function returns the polarization basis in the calibration table
        ('L' for linear or 'C' for circular).
        """
        return self._swigobj.polbasis()

    def numfield(self):
        """This member function returns the number of fields in the calibration table.
        """
        return self._swigobj.numfield()

    def field(self, name=True):
        """This member function returns the fields in the calibration table.
        """
        return self._swigobj.field(name)

    def numantenna(self):
        """This member function returns the number of antennas in the calibration table.
        """
        return self._swigobj.numantenna()

    def numantenna1(self):
        """This member function returns the number of antenna 1s in the calibration table.
        """
        return self._swigobj.numantenna1()

    def numantenna2(self):
        """This member function returns the number of antenna 2s in the calibration table.
        """
        return self._swigobj.numantenna2()

    def antenna(self, name=True):
        """This member function returns the antennas in the calibration table.
        """
        return self._swigobj.antenna(name)

    def antenna1(self, name=True):
        """This member function returns the antenna 1s in the calibration table.
        """
        return self._swigobj.antenna1(name)

    def antenna2(self, name=True):
        """This member function returns the antenna 2s in the calibration table.
        """
        return self._swigobj.antenna2(name)

    def numfeed(self):
        """This member function returns the number of feeds in the calibration table.
        """
        return self._swigobj.numfeed()

    def feed(self):
        """This member function returns the feeds in the calibration table.
        """
        return self._swigobj.feed()

    def numtime(self):
        """This member function returns the number of times in the calibration table.
        """
        return self._swigobj.numtime()

    def time(self):
        """This member function returns the times (in MJD seconds) in the calibration
        table.
        """
        return self._swigobj.time()

    def numspw(self):
        """This member function returns the number of spectral windows in the calibration
        table.
        """
        return self._swigobj.numspw()

    def spw(self, name=True):
        """This member function returns the spectral windows in the calibration table.
        """
        return self._swigobj.spw(name)

    def numchannel(self):
        """This member function returns the number of channels per spectral window in the
        calibration table.
        """
        return self._swigobj.numchannel()

    def freq(self):
        """This member function returns the frequencies per spectral window in the
        calibration table.
        """
        return self._swigobj.freq()

    def get(self, field=[ ], antenna=[ ], timerange=[ ], spw=[ ], feed=[ ], axis='TIME', ap='AMPLITUDE', norm=False, unwrap=False, jumpmax=float(0.0)):
        """This member function returns the calibration data.
        """
        return self._swigobj.get(field, antenna, timerange, spw, feed, axis, ap, norm, unwrap, jumpmax)

    def fit(self, field=[ ], antenna=[ ], timerange=[ ], spw=[ ], feed=[ ], axis='TIME', ap='AMPLITUDE', norm=False, unwrap=False, jumpmax=float(0.0), order='AVERAGE', type='LSQ', weight=False):
        """This member function returns the calibration data and fits along the
        non-iteration axis.
        """
        return self._swigobj.fit(field, antenna, timerange, spw, feed, axis, ap, norm, unwrap, jumpmax, order, type, weight)

