##################### generated by xml-casa (v2) from msmetadata.xml ################
##################### f8044f2323cb192c8f36b31bf6064627 ##############################
from __future__ import absolute_import 
from .__casac__.msmetadata import msmetadata as _msmetadata

from .errors import create_error_string
from .typecheck import CasaValidator as _validator
_pc = _validator( )
from .coercetype import coerce as _coerce


class msmetadata:
    _info_group_ = """msmd"""
    _info_desc_ = """Operations to retrieve metadata from a measurment set"""
    ### self
    def __init__(self, *args, **kwargs):
        """
        """
        self._swigobj = kwargs.get('swig_object',None)
        if self._swigobj is None:
            self._swigobj = _msmetadata()

    def almaspws(self, chavg=False, fdm=False, sqld=False, tdm=False, wvr=False, complement=False):
        """Get spectral window IDs based on ALMA-specific criteria. The inputs are or'ed together
        to form the returned list. If complement=True, then the complement of the selection
        is returned.
        
        If the SPECTRAL_WINDOW table has the optional BBC_NO column and if the name
        of the spectral window matches the regular expression "BB_[0-9]#SQLD", where
        [0-9] indicates that a single integer matches, the window is classified as
        a *square law detector spectral window*.
        
        The following algorithm is used to identify WVR spwectral windows:
        
        1. check for water vapor radiometer (WVR) spectral windows using the spectral window
        name "WVR#NOMINAL" and report these.
        2. If no SPWs match that string, then the names are checked for "WVR" and are reported instead.
        
        If the window is not found to be a WVR window, it is then checked if
        
        The window is classified as a *channel average spectral window* if it is not
        a WVR window, if the number of channels is one, and the spectral window name
        does not contain the string "FULL_RES"
        
        The window is classified as an *FDM window* if it is neither a WVR window nor
        a channel average window and if either
        
        1. its bandwidth is less than 2 GHz, or
        2. the number of channels it contains is greater than or equal to 15 but not
        equal to 256, 128, 64, 32, 16, 248, 124, 62, or 31.
        
        The window is classified as a *TDM spectral window* if it is neither a WVR window,
        a channel average window, nor an FDM window.
        
        
        """
        return self._swigobj.almaspws(chavg, fdm, sqld, tdm, wvr, complement)

    def antennadiameter(self, antenna=int(-1)):
        """Get the diameter for the specified antenna. The antenna can be specified either by
        its zero-based ID from the ANTENNA table or by its name in that table. The returned
        dictionary is a valid quantity. If a negative integer is provided for the antenna, then
        all atenna diameters will be returned in a dictionary that has keys that are the antenna IDs
        and values that are dictionaries, each being a valid quantity representing the diameter for
        that antenna ID.
        
        """
        return self._swigobj.antennadiameter(antenna)

    def antennaids(self, name='', mindiameter='0m', maxdiameter='1pc', obsid=int(-1)):
        """Get the zero-based antenna IDs for the specfied antenna names and the specified diameter
        range for the specified observation ID. An array of unique IDs in order of the specified names is returned.
        Note that if a specified name is listed mulitple times in the ANTENNA table, the largest
        ID is returned, unless the observation ID is specified to be non-negative, in which case, the
        returned IDs are filtered based on the specified observation ID.
        If no names and no diameter range is specified, all IDs are returned.
        
        """
        return self._swigobj.antennaids(name, mindiameter, maxdiameter, obsid)

    def antennanames(self, antennaids=int(-1)):
        """Get the name of the antenna for the specfied zero-based antenna ID. If antennaids is not specified,
        all antenna names are returned.
        
        """
        return self._swigobj.antennanames(antennaids)

    def antennaoffset(self, which=int(0)):
        """Get the offset position of the specified antenna relative to the array reference position. Antenna may
        be specified as a zero-based integer (row number in the ANTENNA table) or a string representing a valid
        antenna name. The returned
        record contains the longitude, latitude, and elevation offsets as quantity records. The reported longitude and
        latitude offsets are measured along the surface of a sphere whose center is coincident with the center of
        the earth and whose surface contains the observatory reference position.
        
        """
        return self._swigobj.antennaoffset(which)

    def antennaposition(self, which=int(0)):
        """Get the position of the specified antenna. The returned record represents a position measure,
        and can be used as such by the measures (me) tool.
        
        """
        return self._swigobj.antennaposition(which)

    def antennastations(self, which=int(-1), obsid=int(-1)):
        """Get the station names of the specified antennas. If a specified antenna name is listed multiple
        times in the ANTENNA table, obsid is negative, and which is specified as an array of names, then
        the station associated with the largest ID for that antenna is returned. If obsid is nonnegative,
        returned stations are filtered based on that. If which is specified as a string (antenna name),
        then all the stations associated with that antenna are returned.
        
        """
        return self._swigobj.antennastations(which, obsid)

    def antennasforscan(self, scan=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique antennaIDs for the specified scan, observation ID, and array ID.
        
        """
        return self._swigobj.antennasforscan(scan, obsid, arrayid)

    def bandwidths(self, spw=int(-1)):
        """Get the bandwidths in Hz for the specified spectral windows. If spw less than zero, return bandwidths for all spectral windows.
        
        """
        return self._swigobj.bandwidths(spw)

    def baseband(self, spw):
        """Get the baseband for the specified spectral window.
        
        """
        return self._swigobj.baseband(spw)

    def baselines(self):
        """Get a two dimensional boolean array representing baselines for data recorded in the MS. A value of True means
        there is at least one row in the MS main table for that baseline, False means no rows for that baseline. Autocorrelation
        "baseline" information is also present via the values along the diagonal.
        
        """
        return self._swigobj.baselines()

    def chanavgspws(self):
        """Get an array of spectral window IDs used for channel averages. These are windows that do have 1 channel.
        
        """
        return self._swigobj.chanavgspws()

    def chaneffbws(self, spw, unit='', asvel=False):
        """Get an array of channel effective bandwidths for the specified spectral window. The parameter
        asvel indicates if velocity widths (True) or frequency widths (False) should be returned.
        The unit parameter specifies the units that the returned values should have. If empty (default),
        "Hz" will be used if asvel=False, or "km/s" will be used if asvel=True.
        
        """
        return self._swigobj.chaneffbws(spw, unit, asvel)

    def chanfreqs(self, spw, unit='Hz'):
        """Get an array of channel frequencies for the specified spectral window.
        
        """
        return self._swigobj.chanfreqs(spw, unit)

    def chanres(self, spw, unit='', asvel=False):
        """Get an array of channel resolutions for the specified spectral window. The parameter
        asvel indicates if velocity widths (True) or frequency widths (False) should be returned.
        The unit parameter specifies the units that the returned values should have. If empty (default),
        "Hz" will be used if asvel=False, or "km/s" will be used if asvel=True.
        
        """
        return self._swigobj.chanres(spw, unit, asvel)

    def chanwidths(self, spw, unit='Hz'):
        """Get an array of channel widths for the specified spectral window.
        
        """
        return self._swigobj.chanwidths(spw, unit)

    def close(self):
        """This method will close the tool and reclaim system resources it has been using. Returns true if successful.
        
        """
        return self._swigobj.close()

    def corrbit(self, spw=int(-1)):
        """Get the value of SPECTRAL_WINDOW::SDM_CORR_BIT column for the specified spw.
        If spw >= 0 is specified, a string value is returned. If spw <0, a list
        of string values with length equal to the number of spectral windows is returned.
        If the SPECTRAL_WINDOW::SDM_CORR_BIT column does not exist, either
        "UNKNOWN" is returned if spw>=0, or a list with nspw entries of
        "UNKNOWN" is returned if spw<0. A list of integers may also be
        supplied for the spw parameter. In this case, all integers should be in the
        range [0, spw-1] or an exception will be thrown. The return value will
        be a list containing the corresponding CORR_BIT values in the order
        of the spws specified.
        
        """
        return self._swigobj.corrbit(spw)

    def corrprodsforpol(self, pol=int(-1)):
        """Get the correlation products associated with the specified polarization ID.
        
        """
        return self._swigobj.corrprodsforpol(pol)

    def corrtypesforpol(self, pol=int(-1)):
        """Get the correlation types associated with the specified polarization ID.
        
        """
        return self._swigobj.corrtypesforpol(pol)

    def datadescids(self, spw=int(-1), pol=int(-1)):
        """Get a list of data description IDs associated with the specified spectral window ID
        and/or polarization ID. Values of less than zero for either means all IDs should be used
        in the selection.
        
        """
        return self._swigobj.datadescids(spw, pol)

    def done(self):
        """This method will close the tool and reclaim system resources it has been using. Returns true if successful.
        
        """
        return self._swigobj.done()

    def effexposuretime(self):
        """Get the effective exposure time (equivalent to what might be more commonly known as total integration
        time or total sample time) is calculated by summing over all rows in the main MS table, excluding
        autocorrelations or rows where FLAG_ROW is false, thusly:
        
        sum[over i] (exposure[i]*sum[over j](UFBW[i, j])/ncorrelations[i] )/ nmaxbaselines
        
        where exposure[i] is the value of EXPOSURE for the ith row, the inner sum is performed over each correlation
        for that row, UFBW is the unflagged fractional bandwidth is determined by summing all the widths of the
        unflagged channels for that correlation and dividing by the total bandwidth of all spectral windows observed
        at the timestamp of row i, ncorrelations is the number of correlations determined by the number of rows in
        the FLAG matrix for MS row i, and nmaxbaselines is the maximum number of antenna pairs,
        nantennas*(nantennas-1)/2, where nantennas is the number of antennas in the ANTENNA table. This method returns
        a quantity (a dictionary having a numerical value and a string unit).
        
        """
        return self._swigobj.effexposuretime()

    def exposuretime(self, scan=int(0), spwid=int(0), polid=int(-1), obsid=int(0), arrayid=int(0)):
        """Get the exposure time for the specified scan, spwid, polarization ID, array ID, and observation ID.
        This is the exposure time of the record with the lowest time stamp of the records associated with
        these parameters. Returns a quantity dictionary. If polid is not specified (or specified and negative)
        and there is only one polarization ID in for the specified combination of scan, spwid, obsID, and
        arrayID, then that polarization ID is used. If there are multiple polarization IDs for the
        combination of other parameters, a list of these is logged and an empty dictionary is returned.
        
        """
        return self._swigobj.exposuretime(scan, spwid, polid, obsid, arrayid)

    def fdmspws(self):
        """Get an array of spectral window IDs used for FDM. These are windows that do not have 64, 128, or 256 channels.
        
        """
        return self._swigobj.fdmspws()

    def fieldnames(self):
        """Get an array of field names as they appear in the FIELD table.
        
        """
        return self._swigobj.fieldnames()

    def fieldsforintent(self, intent='', asnames=False):
        """Get an array of the unique fields for the specified intent. Note that * matches any number of characters of all character classes.
        
        """
        return self._swigobj.fieldsforintent(intent, asnames)

    def fieldsforname(self, name=''):
        """Get an array of the unique, zero-based field IDs for the specified field name. If the field name is the
        empty string (the default), a list of all unique field IDs in the main table of the MS will be returned.
        
        """
        return self._swigobj.fieldsforname(name)

    def fieldsforscan(self, scan=int(-1), asnames=False, obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique fields for the specified scan number, observation ID, and array ID.
        
        """
        return self._swigobj.fieldsforscan(scan, asnames, obsid, arrayid)

    def fieldsforscans(self, scans=[  ], asnames=False, obsid=int(-1), arrayid=int(-1), asmap=False):
        """Get an array or dictionary of the unique fields for the specified scan numbers, observation ID, and array ID.
        If asnames=True, the values returned will be the field names, if False, they will be field IDs.
        If asmap=True, the structure returned will be a dictionary which maps scan number (as a string) to fields.
        In this case, both obsid and arrayid must be nonnegative. If asmap=False, a single array of fields is returned
        that matches the query. In this case, if obsid and/or arrayid are negative, then it indicates that all
        fields matching any obsid and/or arrayid should be returned. An empty array specified for scans means
        that all scans for the selected obsid and arrayid should be included.
        
        """
        return self._swigobj.fieldsforscans(scans, asnames, obsid, arrayid, asmap)

    def fieldsforsource(self, source=int(-1), asnames=False):
        """Get an array of the unique fields for the specified source.
        
        """
        return self._swigobj.fieldsforsource(source, asnames)

    def fieldsforsources(self, asnames=False):
        """Get a map of source IDs to fields. The keys (source IDs) will be strings.
        
        """
        return self._swigobj.fieldsforsources(asnames)

    def fieldsforspw(self, spw=int(-1), asnames=False):
        """Get an array of the unique fields for the specified spectral window.
        
        """
        return self._swigobj.fieldsforspw(spw, asnames)

    def fieldsfortimes(self, time=float(-1), tol=float(0)):
        """Get an array of the unique, zero-based, fieldIDs for the specified time range (time-tol to time+tol).
        
        """
        return self._swigobj.fieldsfortimes(time, tol)

    def intents(self):
        """Get an array of the unique intents associated with the MS.
        
        """
        return self._swigobj.intents()

    def intentsforfield(self, field=int(0)):
        """Get an array of the unique intents for the specified field.
        
        """
        return self._swigobj.intentsforfield(field)

    def intentsforscan(self, scan=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique intents for the specified scan, observation ID, and array ID.
        
        """
        return self._swigobj.intentsforscan(scan, obsid, arrayid)

    def intentsforspw(self, spw=int(-1)):
        """Get an array of the unique intents for the specified spectral window ID.
        
        """
        return self._swigobj.intentsforspw(spw)

    def meanfreq(self, spw, unit='Hz'):
        """Get the mean frequency for the specified spectral window.
        
        """
        return self._swigobj.meanfreq(spw, unit)

    def name(self):
        """Get the name of the attached MS.
        
        """
        return self._swigobj.name()

    def namesforfields(self, fieldids=''):
        """Get the name of the specified field.
        
        """
        return self._swigobj.namesforfields(fieldids)

    def namesforspws(self, spwids=''):
        """Get the name of the specified spw(s).
        
        """
        return self._swigobj.namesforspws(spwids)

    def nantennas(self):
        """Get the number of antennas associated with the MS.
        
        """
        return self._swigobj.nantennas()

    def narrays(self):
        """Get the number of arrays associated with the MS from the ARRAY table.
        
        """
        return self._swigobj.narrays()

    def nbaselines(self, ac=False):
        """Get the number of unique baselines (antenna pairs) represented in the main MS table. This can, in theory, be less than
        n*(n-1)/2 (n being the number of antennas in the ANTENNA table), if data for certain baselines
        are not included in the main MS table. Autocorrelation "baselines" are included in this count if ac=True.
        
        """
        return self._swigobj.nbaselines(ac)

    def nchan(self, spw):
        """Get the number of channels associated with the specified spectral window.
        
        """
        return self._swigobj.nchan(spw)

    def ncorrforpol(self, polid=int(-1)):
        """Get the number of correlations for the specified polarization ID. If the specified polarization ID
        is negative, an array of numbers of correlations is returned. The indices of that array represent polarization IDs.
        
        """
        return self._swigobj.ncorrforpol(polid)

    def nfields(self):
        """Get the number of fields associated with the MS.
        
        """
        return self._swigobj.nfields()

    def nobservations(self):
        """Get the number of observations associated with the MS from the OBSERVATIONS table.
        
        """
        return self._swigobj.nobservations()

    def nspw(self, includewvr=True):
        """This method will return the number of spectral windows in the associated MS.
        
        """
        return self._swigobj.nspw(includewvr)

    def nstates(self):
        """This method will return the number of states (number of rows in the STATES table) in the associated MS.
        
        """
        return self._swigobj.nstates()

    def nscans(self):
        """Get the number of scans associated with the MS.
        
        """
        return self._swigobj.nscans()

    def nsources(self):
        """Get the number of unique values from the SOURCE_ID column in the SOURCE table. The number of rows in the
        SOURCE table may be greater than this value.
        
        """
        return self._swigobj.nsources()

    def nrows(self, autoc=True, flagged=True):
        """Get the number of visibilities (from the main table) associated with the MS.
        
        """
        return self._swigobj.nrows(autoc, flagged)

    def observers(self):
        """Get an array of observers as they are listed in the OBSERVATIONS table.
        
        """
        return self._swigobj.observers()

    def observatorynames(self):
        """Get an array of MS telescope (observatory) names as they are listed in the OBSERVATIONS table.
        
        """
        return self._swigobj.observatorynames()

    def observatoryposition(self, which=int(0)):
        """Get the position of the specified telescope.
        
        """
        return self._swigobj.observatoryposition(which)

    def open(self, msfile='', maxcache=float(50)):
        """Attach this tool to the specified MS. This method runs a few basic MS validation tests, and if any of these
        fail (which indicates that the MS is invalid), an error occurs and the tool is not attached to the MS.
        Note that it is ultimately the user's responsibility to ensure that the MS is valid. Running the methods
        of this tool on an invalid MS may result in incorrect results or even a crash of CASA. Such invalidities
        include any MS subtable not having appropriate information (eg, an OBSERVATION subtable not having enough rows
        to account for all the OBSERVATION_IDs in the main table).
        
        """
        return self._swigobj.open(msfile, maxcache)

    def phasecenter(self, fieldid=int(0), epoch={ }):
        """Get a direction measures for the phasecenter of the field id and time specified
        
        """
        return self._swigobj.phasecenter(fieldid, epoch)

    def pointingdirection(self, rownum=int(0), interpolate=False, initialrow=int(0)):
        """Get the pointing direction for antennas at the specified row number in the main MS table. Returns a record
        containing the time, antenna IDs and corresponding pointing directions.
        
        """
        return self._swigobj.pointingdirection(rownum, interpolate, initialrow)

    def polidfordatadesc(self, ddid=int(-1)):
        """Get the polarization ID associated with the specified data description ID. If the specified data description ID
        is negative, an array of polarization IDs is returned. The indices of that array represent data description IDs.
        
        """
        return self._swigobj.polidfordatadesc(ddid)

    def projects(self):
        """Get an array of projects as they are listed in the OBSERVATIONS table.
        
        """
        return self._swigobj.projects()

    def propermotions(self):
        """Get the values of the DIRECTION column from the SOURCE table. Returns a dictionary in which the
        keys are the associated zero-based row numbers, represented as strings, in the SOURCE table. The
        associated values are two element dictionaries, with keys "longitude" and "latitude", containing
        the longitudinal and latidinal components of the proper motion, which are valid quantity dictionaries.
        
        """
        return self._swigobj.propermotions()

    def refdir(self, field=int(0), epoch={ }):
        """Get a direction measure for the reference direction of the field and time specified
        
        """
        return self._swigobj.refdir(field, epoch)

    def reffreq(self, spw=int(-1)):
        """Get the reference frequency of the specified spectral window. The returned frequency is in
        the form of a valid measures dictionary.
        
        """
        return self._swigobj.reffreq(spw)

    def restfreqs(self, sourceid=int(0), spw=int(0)):
        """Get the rest frequencies from the SOURCE table for the specified source and spectral window.
        The return value will be a dictionary of frequency measures if the rest frequencies are
        defined for the specified inputs, or False if they do not.
        
        """
        return self._swigobj.restfreqs(sourceid, spw)

    def rxbands(self, spwids=''):
        """ALMA-only. Returns an integer array containing the receiver band
        of the specified spw(s). A return value of -1 means no receiver
        band number could be determined. The name of the spw is first
        checked to determine if the receiver band value is encoded
        there. If not, the corresponding spectral window ID is sought in
        the ASDM_RECEIVER table, if it exists, and if it has less than
        or equal number of rows compared to the SPECTRAL_WINDOW table.
        If the corresponding spectral window can be found in the
        ASDM_RECEIVER table, then the corresponding frequencyBand column
        value is checked to determine if the receiver band information
        is encoded there. In the case where the spectral window ID is
        present in multiple cells of the spectralWindowId column, the
        first row in which the ID is found is used to determine the
        receiver band. If all these tests fail, -1 is returned for the
        specified spectral window.
        
        """
        return self._swigobj.rxbands(spwids)

    def scannumbers(self, obsid=int(-1), arrayid=int(-1)):
        """This method will return an array of unique scan numbers in the associated MS for the specified observation ID and array ID.
        
        """
        return self._swigobj.scannumbers(obsid, arrayid)

    def scansforfield(self, field='', obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique scan numbers associated with the specified field, observation ID, and array ID.
        
        """
        return self._swigobj.scansforfield(field, obsid, arrayid)

    def scansforfields(self, obsid=int(0), arrayid=int(0)):
        """Get a dictionary of which maps field ID to scan numbers for the specified observation ID
        and array ID. The keys (field IDs) will be strings. obsid and arrayid must both
        be non-negative.
        
        """
        return self._swigobj.scansforfields(obsid, arrayid)

    def scansforintent(self, intent='', obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique scan numbers associated with the specified intent, observation ID, and arrayID.
        The "*" character matches any number of characters from all character classes.
        
        """
        return self._swigobj.scansforintent(intent, obsid, arrayid)

    def scansforspw(self, spw=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique scan numbers associated with the specified zero-based spectral window ID, observation ID, and array ID.
        
        """
        return self._swigobj.scansforspw(spw, obsid, arrayid)

    def scansforspws(self, obsid=int(0), arrayid=int(0)):
        """Get a dictionary of which maps spw ID to scan numbers for the specified observation ID
        and array ID. The keys (spectral window IDs) will be strings. obsid and arrayid must both
        be non-negative.
        
        """
        return self._swigobj.scansforspws(obsid, arrayid)

    def scansforstate(self, state=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique scan numbers for the specified state, observation ID, and array ID.
        
        """
        return self._swigobj.scansforstate(state, obsid, arrayid)

    def scansfortimes(self, time=float(-1), tol=float(0), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique scan numbers for the specified time range (time-tol to time+tol), observation ID, and array ID.
        
        """
        return self._swigobj.scansfortimes(time, tol, obsid, arrayid)

    def schedule(self, obsid=int(-1)):
        """Get the schedule information for the specified observation ID.
        
        """
        return self._swigobj.schedule(obsid)

    def sideband(self, spw):
        """Get the sideband for the specified spectral window.
        
        """
        return self._swigobj.sideband(spw)

    def sourcedirs(self):
        """Get the values of the DIRECTION column from the SOURCE table. Returns a dictionary in which the
        keys are the associated row numbers, represented as strings, in the SOURCE table. Each value
        in the returned dictionary is a valid direction measure.
        
        """
        return self._swigobj.sourcedirs()

    def sourcetimes(self):
        """Get the values of the TIME column from the SOURCE table. Returns a dictionary in which the
        keys are the associated row numbers, represented as strings, in the SOURCE table. Each value
        in the returned dictionary is a valid time quantity.
        
        """
        return self._swigobj.sourcetimes()

    def sourceidforfield(self, field=int(-1)):
        """Get the source ID from the field table for the specified field ID.
        
        """
        return self._swigobj.sourceidforfield(field)

    def sourceidsfromsourcetable(self):
        """Get the values of the SOURCE_ID column from the SOURCE table. It is unfortunate that the SOURCE
        table has a column named SOURCE_ID, because implicitly the "ID" of a row in an MS subtable is
        generally meant to reflect a row number in that table, but that is not the case for the SOURCE table.
        
        """
        return self._swigobj.sourceidsfromsourcetable()

    def sourcenames(self):
        """Get the values of the SOURCE_NAME column from the SOURCE table.
        
        """
        return self._swigobj.sourcenames()

    def spwsforbaseband(self, baseband=int(-1), sqldmode='include'):
        """Get the spectral windows associated with the specified baseband or dictionary that maps baseband to spectral windows.
        
        """
        return self._swigobj.spwsforbaseband(baseband, sqldmode)

    def spwfordatadesc(self, ddid=int(-1)):
        """Get the spectral window ID associated with the specified data description ID. If the specified data description ID
        is negative, an array of spectral window IDs is returned. The indices of that array represent data description IDs.
        
        """
        return self._swigobj.spwfordatadesc(ddid)

    def spwsforfield(self, field=''):
        """Get an array of the unique spectral window IDs for the specified field.
        
        """
        return self._swigobj.spwsforfield(field)

    def spwsforfields(self):
        """Get a dictionary which maps field IDs to spectral window IDs. The field IDs are keys in the
        returned dictionary. To access a particular element, one must ensure the key is a string.
        
        """
        return self._swigobj.spwsforfields()

    def spwsforintent(self, intent=''):
        """Get an array of the unique spectral window IDs for the specified intent. The "*" character matches any number of characters from all character classes.
        
        """
        return self._swigobj.spwsforintent(intent)

    def spwsfornames(self, spwids=''):
        """Get the IDs of the specified spw(s). Returns a dictionary where the keys
        are the requested spectral window names that are present in the data set
        and the values are arrays of the spectral window IDs corresponding to the
        name. If a specified name is not present, a warning message is logged and
        that name is not included in the returned dictionary. Specifying no names
        results in a dictionary containing the name to spw ID mapping for the
        entire data set.
        
        """
        return self._swigobj.spwsfornames(spwids)

    def spwsforscan(self, scan=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique spectral window IDs for the specified scan number, observation ID, and array ID.
        
        """
        return self._swigobj.spwsforscan(scan, obsid, arrayid)

    def spwsforscans(self, obsid=int(0), arrayid=int(0)):
        """Get a dictionary of which maps scan number to spectral windows for the specified observation ID and array ID. The keys (scan
        numbers) will be strings. obsid and arrayid must both be non-negative.
        
        """
        return self._swigobj.spwsforscans(obsid, arrayid)

    def subwindows(self, spwids=''):
        """ALMA-only. Returns an integer array containing the subwindow of
        the specified spw(s). The spw name is checked to determine if
        the subwindow value is encoded within it. A return value of -1
        indicates that a subwindow number could be determined.
        
        """
        return self._swigobj.subwindows(spwids)

    def statesforscan(self, scan=int(-1), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique state IDs for the specified scan number, observation ID, and array ID.
        
        """
        return self._swigobj.statesforscan(scan, obsid, arrayid)

    def statesforscans(self, obsid=int(0), arrayid=int(0)):
        """Get a dictionary which maps scan numbers to state IDs for the specified array and observation IDs. The returned dictionary
        will have scan numbers, as strings, as keys.
        
        """
        return self._swigobj.statesforscans(obsid, arrayid)

    def summary(self):
        """Get dictionary summarizing the MS.
        
        """
        return self._swigobj.summary()

    def tdmspws(self):
        """Get an array of spectral window IDs used for TDM. These are windows that have 64, 128, or 256 channels.
        
        """
        return self._swigobj.tdmspws()

    def timerangeforobs(self, obsid=int(-1)):
        """Get the time range for the specified observation ID. The return value is a dictionary containing
        keys "begin" and "end". Each of the associated value are dictionaries representing epochs which
        are valid measure records. The values are taken directly from the OBSERVATION subtable; no
        half-intervals are added or subtracted.
        
        """
        return self._swigobj.timerangeforobs(obsid)

    def timesforfield(self, field=int(-1)):
        """Get an array of the unique times associated with the specified field ID. The times correspond to those in the TIME column, so are values of the time system associated with that column and have units associated with that column. Only unique times are returned; duplicates are dropped. Providing a negative field ID will result in an exception being thrown.
        
        """
        return self._swigobj.timesforfield(field)

    def timesforintent(self, intent=''):
        """Get an array of the unique times associated with the specified intent.  The times correspond to those in the TIME column, so are values of the time system associated with that column and have units associated with that column. Only unique times are returned; duplicates are dropped.
        
        """
        return self._swigobj.timesforintent(intent)

    def timesforscan(self, scan=int(-1), obsid=int(-1), arrayid=int(-1), perspw=False):
        """Get the unique times for the specified scan number, observation ID, and array ID. If perspw=True, the returned data structure is
        a dictionary that has keys representing zero-based spectral window IDs and values representing the unique values of the TIME column
        corrsponding to the specified scan and that corresponding spectral window ID. If False, an array of unique values from the TIME
        column for the specified scan is returned; there is no separation into spectral window IDs.
        
        """
        return self._swigobj.timesforscan(scan, obsid, arrayid, perspw)

    def timesforscans(self, scans=int(0), obsid=int(-1), arrayid=int(-1)):
        """Get an array of the unique times for the specified scan numbers, observation ID, and array ID.  The times correspond to those in the TIME column, so are values of the time system associated with that column and have units associated with that column. Only unique times are returned; duplicates are dropped. For the scans parameter, a single non-negative integer or a list of non-negative integers, all of which are valid scan numbers in the MS, must be supplied.
        
        """
        return self._swigobj.timesforscans(scans, obsid, arrayid)

    def timesforspws(self, spw=int(-1)):
        """Get the unique times corresponding to the specified spectral window(s). The input indicates the
        spws for which times are to be retrieved, and can be a single integer or an array of
        integers. If a single, non-negative integer, an array of unique times associated with
        that spectral window are returned. Otherwise, a dictionary of times associated with the
        specified spectral windows are returned, with the spws (as strings) as the keys and the
        times as the values. A negative integer will cause a dictionary of all spws and their
        associated times to be returned.
        
        """
        return self._swigobj.timesforspws(spw)

    def transitions(self, sourceid=int(0), spw=int(0)):
        """Get the spectral transitions from the SOURCE table for the specified source and spectral window.
        The return value will be an array of transitions if the transitions are
        defined for the specified inputs, or False if they do not.
        
        """
        return self._swigobj.transitions(sourceid, spw)

    def wvrspws(self, complement=False):
        """Get an array of spectral window IDs used for WVR. These are windows that have 4 channels.
        If complement is True, return the complement set instead (all non-wvr spw IDs). WVR windows
        are identified using the algorithm
        1. check for water vapor radiometer (WVR) spectral windows using the spectral window
        name "WVR#NOMINAL" and report these.
        2. If no SPWs match that string, then the names are checked for "WVR" and are reported instead.
        
        """
        return self._swigobj.wvrspws(complement)

